Imports System.ComponentModel

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        WithOptional()
        WithOverloads()

        Dim cust1 As New CustomerWithOverloads()

        Dim cust2 As New CustomerWithOptional()
        Dim cust3 As New CustomerWithOptional("Rod", , "1337 Leet St")
        Dim cust4 As New CustomerWithOptional( _
            new_FirstName:="Rod", new_Street:="1337 Leet St")

        ' cust1.ShowNumber(CInt(111))
        ' cust1.ShowNumber(CLng(222))

        Debug.WriteLine(WeightedAverage(New Single() {1, 2}, New Single() {1, 2}))
        Debug.WriteLine(WeightedAverage(New Single() {1, 2, 3}, New Single() {1, 2, 3}))

        '' Debug.WriteLine(Sum())
        'Debug.WriteLine(Sum(Nothing))
        'Debug.WriteLine(Sum(1, Nothing, 3))
        'Debug.WriteLine(Sum(1, 2, 3))
        'Debug.WriteLine(Sum(New Integer() {1, 2, 3, 4}))

        '' Debug.WriteLine(Sum2())
        '' Debug.WriteLine(Sum2(Nothing))
        'Debug.WriteLine(Sum2(New Integer() {1, Nothing, 3}))
        'Debug.WriteLine(Sum2(New Integer() {1, 2, 3}))
        'Debug.WriteLine(Sum2(New Integer() {1, 2, 3, 4}))

        Me.Close()
    End Sub

    ' Return the sum of the numbers.
    Private Function Sum(ByVal ParamArray args() As Integer) As Integer
        Debug.Assert(args IsNot Nothing, "Sum cannot take empty parameter list")
        Debug.Assert(args.Length >= 2, "Sum must take at least two parameters")

        Dim total As Integer = 0
        For i As Integer = 0 To args.Length - 1
            total += args(i)
        Next i
        Return total
    End Function

    Private Function Sum2(ByVal args() As Integer) As Integer
        Debug.Assert(args IsNot Nothing, "Sum cannot take empty parameter list")
        Debug.Assert(args.Length >= 2, "Sum must take at least two parameters")

        Dim total As Integer = 0
        For i As Integer = 0 To args.Length - 1
            total += args(i)
        Next i
        Return total
    End Function

    ' Calculate the weighted average of a series of numbers.
    Private Function WeightedAverage(ByVal values() As Single, ByVal weights() As Single) As Single
        Debug.Assert(values IsNot Nothing, "WeightedAverage: values parameter must not be Nothing")
        Debug.Assert(weights IsNot Nothing, "WeightedAverage: weights parameter must not be Nothing")
        Debug.Assert(values.Length = weights.Length, "WeightedAverage: values and weights arrays must have the same length")

        Dim total_values As Single = 0
        Dim total_weight As Single = 0
        For i As Integer = 0 To values.Length - 1
            total_values += values(i) * weights(i)
            total_weight += weights(i)
        Next i
        Return total_values / total_weight
    End Function

    ' Uses optional parameters.
    Private Sub WithOptional(Optional ByVal arg1 As Integer = 1, Optional ByVal arg2 As Integer = 2, Optional ByVal arg3 As Integer = 3, Optional ByVal arg4 As Integer = 4, Optional ByVal arg5 As Integer = 5)

    End Sub

    ' Overloaded versions.
    Private Sub WithOverloads()
    End Sub
    Private Sub WithOverloads(ByVal arg1 As Integer)
    End Sub
    Private Sub WithOverloads(ByVal arg1 As Integer, ByVal arg2 As Integer)
    End Sub
    Private Sub WithOverloads(ByVal arg1 As Integer, ByVal arg2 As Integer, ByVal arg3 As Integer)
    End Sub
    Private Sub WithOverloads(ByVal arg1 As Integer, ByVal arg2 As Integer, ByVal arg3 As Integer, ByVal arg4 As Integer)
    End Sub
    Private Sub WithOverloads(ByVal arg1 As Integer, ByVal arg2 As Integer, ByVal arg3 As Integer, ByVal arg4 As Integer, ByVal arg5 As Integer)
    End Sub

End Class

Public Class CustomerWithOverloads
    Public FirstName As String
    Public LastName As String
    Public Street As String
    Public City As String
    Public State As String
    Public Zip As String

    ''' <summary>
    ''' Create a new Customer with default name and address.
    ''' </summary>
    ''' <remarks></remarks>
    <Description("Create a new Customer with default name and address")> _
    Public Sub New()
        Me.New("")
    End Sub

    ''' <summary>
    ''' Create a new Customer with a given first name and a default address.
    ''' </summary>
    ''' <param name="new_FirstName">The new customer's first name.</param>
    ''' <remarks></remarks>
    <Description("Create a new Customer with a given first name and a default address")> _
    Public Sub New(ByVal new_FirstName As String)
        Me.New(new_FirstName, "")
    End Sub

    ''' <summary>
    ''' Create a new Customer with a given first and last name, and a default address.
    ''' </summary>
    ''' <param name="new_FirstName">The new customer's first name.</param>
    ''' <param name="new_LastName">The new customer's first name.</param>
    ''' <remarks></remarks>
    <Description("Create a new Customer with a given first and last name, and a default address")> _
    Public Sub New(ByVal new_FirstName As String, ByVal new_LastName As String)
        Me.New(new_FirstName, new_LastName, "")
    End Sub

    ''' <summary>
    ''' Create a new Customer with a given first name, last name, and street address, and with default city, state, and ZIP code.
    ''' </summary>
    ''' <param name="new_FirstName">The new customer's first name.</param>
    ''' <param name="new_LastName">The new customer's first name.</param>
    ''' <param name="new_Street">The new customer's street address.</param>
    ''' <remarks></remarks>
    <Description("Create a new Customer with a given first name, last name, and street address, and with default city, state, and ZIP code")> _
    Public Sub New(ByVal new_FirstName As String, ByVal new_LastName As String, ByVal new_Street As String)
        Me.New(new_FirstName, new_LastName, new_Street, "")
    End Sub

    ''' <summary>
    ''' Create a new Customer with a given first name, last name, street address, and city, and with default state and ZIP code.
    ''' </summary>
    ''' <param name="new_FirstName">The new customer's first name.</param>
    ''' <param name="new_LastName">The new customer's first name.</param>
    ''' <param name="new_Street">The new customer's street address.</param>
    ''' <param name="new_City">The new customer's city.</param>
    ''' <remarks></remarks>
    <Description("Create a new Customer with a given first name, last name, street address, and city, and with default state and ZIP code")> _
    Public Sub New(ByVal new_FirstName As String, ByVal new_LastName As String, ByVal new_Street As String, ByVal new_City As String)
        Me.New(new_FirstName, new_LastName, new_Street, new_City, "")
    End Sub

    ''' <summary>
    ''' Create a new Customer with a given first name, last name, street address, city, and state, and with a default ZIP code.
    ''' </summary>
    ''' <param name="new_FirstName">The new customer's first name.</param>
    ''' <param name="new_LastName">The new customer's first name.</param>
    ''' <param name="new_Street">The new customer's street address.</param>
    ''' <param name="new_City">The new customer's city.</param>
    ''' <param name="new_State">The new customer's state.</param>
    ''' <remarks></remarks>
    <Description("Create a new Customer with a given first name, last name, street address, city, and state, and with a default ZIP code")> _
    Public Sub New(ByVal new_FirstName As String, ByVal new_LastName As String, ByVal new_Street As String, ByVal new_City As String, ByVal new_State As String)
        Me.New(new_FirstName, new_LastName, new_Street, new_City, new_State, "")
    End Sub

    ''' <summary>
    ''' Create a new Customer with a given name and address.
    ''' </summary>
    ''' <param name="new_FirstName">The new customer's first name.</param>
    ''' <param name="new_LastName">The new customer's first name.</param>
    ''' <param name="new_Street">The new customer's street address.</param>
    ''' <param name="new_City">The new customer's city.</param>
    ''' <param name="new_State">The new customer's state.</param>
    ''' <param name="new_Zip">The new customer's 5-digit ZIP code</param>
    ''' <remarks></remarks>
    <Description("Create a new Customer with a given name and address")> _
    Public Sub New(ByVal new_FirstName As String, ByVal new_LastName As String, ByVal new_Street As String, ByVal new_City As String, ByVal new_State As String, ByVal new_Zip As String)
        FirstName = new_FirstName
        LastName = new_LastName
        Street = new_Street
        City = new_City
        State = new_State
        Zip = new_Zip
    End Sub

    Public Sub ShowNumber(ByVal i As Integer)
        MessageBox.Show("Integer: " & i.ToString())
    End Sub
    Public Sub ShowNumber(ByVal i As Long)
        MessageBox.Show("Long: " & i.ToString())
    End Sub

End Class

Public Class CustomerWithOptional
    Public FirstName As String
    Public LastName As String
    Public Street As String
    Public City As String
    Public State As String
    Public Zip As String

    ''' <summary>
    ''' Create a new Customer with a given name and address.
    ''' </summary>
    ''' <param name="new_FirstName">The new customer's first name.</param>
    ''' <param name="new_LastName">The new customer's first name.</param>
    ''' <param name="new_Street">The new customer's street address.</param>
    ''' <param name="new_City">The new customer's city.</param>
    ''' <param name="new_State">The new customer's state.</param>
    ''' <param name="new_Zip">The new customer's 5-digit ZIP code</param>
    ''' <remarks></remarks>
    <Description("Create a new Customer with a given name and address")> _
    Public Sub New(Optional ByVal new_FirstName As String = "", Optional ByVal new_LastName As String = "", Optional ByVal new_Street As String = "", Optional ByVal new_City As String = "", Optional ByVal new_State As String = "", Optional ByVal new_Zip As String = "")
        FirstName = new_FirstName
        LastName = new_LastName
        Street = new_Street
        City = new_City
        State = new_State
        Zip = new_Zip
    End Sub
End Class